//+------------------------------------------------------------------+
//|              Forex EA and Script Generator version 4.5        EA |
//|                                     Copyright 2012, Etasoft Inc. |
//|                                    http://www.forexgenerator.com |
//+------------------------------------------------------------------+
// Keywords: developer, Forex EA builder, create EA, expert advisor, MT5, MT4

#property copyright "Copyright  2012, Etasoft Inc. Forex EA Generator v4.5"
#property link      "http://www.forexgenerator.com"

#include <Trade\Trade.mqh>

// exported variables
input double Lots2 = 1;
input int Stoploss2 = 5;
input int Takeprofit2 = 100;
input int PriceOffset2 = 3;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;



//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    //---
    NDigits = Digits();
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
    if (AccountInfoInteger(ACCOUNT_TRADE_EXPERT) == false)
    {
        Print("Check terminal options because EA trade option is set to not allowed.");
        Comment("Check terminal options because EA trade option is set to not allowed.");
    }
    
    if (false) ObjectsDeleteAll(0);      // clear the chart
    
    
    Comment("");    // clear the chart
    //---
    return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
    //---
    if (false) ObjectsDeleteAll(0);
    
    
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
    //---
    if (Terminated == true)
    {
        Comment("EA Terminated.");
    }
    
    OnEveryTick1();
}

//+------------------------------------------------------------------+
//| Get Low for specified bar index                                  |
//+------------------------------------------------------------------+
double Low(int index)
{
    double arr[];
    double low = 0;
    ArraySetAsSeries(arr, true);
    int copied = CopyLow(Symbol(), PERIOD_CURRENT, 0, Bars(Symbol(), PERIOD_CURRENT), arr);
    if (copied>0 && index<copied) low = arr[index];
    return (low);
}
//+------------------------------------------------------------------+
//| Get the High for specified bar index                             |
//+------------------------------------------------------------------+
double High(int index)
{
    double arr[];
    double high = 0;
    ArraySetAsSeries(arr, true);
    int copied = CopyHigh(Symbol(), PERIOD_CURRENT, 0, Bars(Symbol(), PERIOD_CURRENT), arr);
    if (copied>0 && index<copied) high=arr[index];
    return(high);
}
//+------------------------------------------------------------------+
//| Get Close for specified bar index                                |
//+------------------------------------------------------------------+
double Close(int index)
{
    double arr[];
    double close = 0;
    ArraySetAsSeries(arr, true);
    int copied = CopyClose(Symbol(), PERIOD_CURRENT, 0, Bars(Symbol(), PERIOD_CURRENT), arr);
    if (copied>0 && index<copied) close = arr[index];
    return (close);
}
//+------------------------------------------------------------------+
//| Get Open for specified bar index                                 |
//+------------------------------------------------------------------+
double Open(int index)
{
    double arr[];
    double open = 0;
    ArraySetAsSeries(arr, true);
    int copied = CopyOpen(Symbol(), PERIOD_CURRENT, 0, Bars(Symbol(), PERIOD_CURRENT), arr);
    if (copied>0 && index<copied) open = arr[index];
    return (open);
}
//+------------------------------------------------------------------+
//| Get current bid value                                            |
//+------------------------------------------------------------------+
double Bid()
{
    return (SymbolInfoDouble(Symbol(), SYMBOL_BID));
}

//+------------------------------------------------------------------+
//| Get current ask value                                            |
//+------------------------------------------------------------------+
double Ask()
{
    return (SymbolInfoDouble(Symbol(), SYMBOL_ASK));
}

//+------------------------------------------------------------------+
//| Is there an error                                                |
//+------------------------------------------------------------------+
bool IsError(MqlTradeResult& result, string function)
{
    if (result.retcode != 0 && result.retcode != TRADE_RETCODE_DONE && result.retcode != TRADE_RETCODE_PLACED)
    {
        Print("Function: ", function, " Error: ", result.retcode, " ", result.comment);
        return (true);
    }
    else
    Print("> Executed: [", function, "]");
    return (false);
}

bool IsError(CTrade& trade, string function)
{
    if (trade.ResultRetcode() != 0 && trade.ResultRetcode() != TRADE_RETCODE_DONE && trade.ResultRetcode() != TRADE_RETCODE_PLACED)
    {
        Print("Function: ", function, " Error: ", trade.ResultRetcode(), " ", trade.ResultRetcodeDescription());
        return (true);
    }
    else
    Print("> Executed: [", function, "]");
    return (false);
}

//+------------------------------------------------------------------+
//| Get indicator value back                                         |
//+------------------------------------------------------------------+
double GetIndicator(int handle, int buffer_num, int index)
{
    //--- array for the indicator values
    double arr[];    
    //--- obtain the indicator value in the last two bars
    if (CopyBuffer(handle, buffer_num, 0, index+1, arr) <= 0)
    {        
        Sleep(200);
        for(int i=0; i<100; i++)
        {
            if (BarsCalculated(handle) > 0)
            break;
            Sleep(50);
        }
        int copied = CopyBuffer(handle, buffer_num, 0, index+1, arr);
        if (copied <= 0)
        {
            Print("CopyBuffer failed. Maybe history has not download yet? Error = ", GetLastError());
            return -1;
        }
        else
        return (arr[index]);
    }
    else
    {
        return (arr[index]);
    }
    
    return 0;
}

//+------------------------------------------------------------------+
//| Building blocks                                                  |
//+------------------------------------------------------------------+
void OnEveryTick1()
{
    
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
    OncePerBar3();
    
}

void OncePerBar3()
{
    static datetime Old_Time;
    datetime New_Time[1];
    // copying the last bar time to the element New_Time[0]
    int copied = CopyTime(Symbol(), Period(), 0, 1, New_Time);
    if (copied > 0)     // ok, the data has been copied successfully
    {
        if (Old_Time != New_Time[0]) // if old time isn't equal to new bar time
        {
            Old_Time=New_Time[0];            // saving bar time
            BuyPendingOrder22();
            
        }
        else
        {
            return;     // still the same bar
        }
    }
    else
    {
        Alert("Error in copying historical times data, error =",GetLastError());
        ResetLastError();
        return;
    }
}

void BuyPendingOrder22()
{
    
    double price = NormalizeDouble(High(2), NDigits) - PriceOffset2*PipValue*Point();
    double SL = price - Stoploss2*PipValue*Point();
    if (Stoploss2 == 0) SL = 0;
    double TP = price + Takeprofit2*PipValue*Point();
    if (Takeprofit2 == 0) TP = 0;
    
    //--- prepare a request
    MqlTradeRequest request;
    ZeroMemory(request);
    request.action=TRADE_ACTION_PENDING;         // setting a pending order
    request.magic = 1;                  // ORDER_MAGIC
    request.symbol = Symbol();                      // symbol
    request.volume = Lots2;                          // volume in 0.1 lots
    request.sl = SL;                                // Stop Loss is not specified
    request.tp = TP;                                // Take Profit is not specified
    request.deviation = 3;                         // deviation in 5 points
    request.price = price;
    request.type_time = ORDER_TIME_SPECIFIED;
    request.expiration = TimeTradeServer()+PeriodSeconds(PERIOD_D1)-2;
    //--- form the order type
    request.type = ORDER_TYPE_BUY_STOP;           // order type ORDER_TYPE_BUY_LIMIT, ORDER_TYPE_SELL_LIMIT, ORDER_TYPE_BUY_STOP, ORDER_TYPE_SELL_STOP
    //--- form the price for the pending order
    MqlTradeResult result;
    ZeroMemory(result);
    OrderSend(request,result);
    // check the result
    if (!IsError(result, __FUNCTION__))
    {
        
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
}





